unit REMOTECONTROL;
{**************************************************************************}
{                                                                          }
{    This C DLL header file first (automatic) conversion generated by:     }
{    HeadConv 4.0 (c) 2000 by Bob Swart (aka Dr.Bob - www.drbob42.com)     }
{      Final Delphi-Jedi (Darth) command-line units edition                }
{                                                                          }
{    Generated Date: 2010.01.18                                            }
{    Generated Time: 14:16:32                                              }
{                                                                          }
{**************************************************************************}

interface
uses
{$IFDEF WIN32}
  Windows;
{$ELSE}
  Wintypes, WinProcs;
{$ENDIF}


{=> REMOTECONTROL.H <=}

{$IFNDEF __REMOTECONTROL_H}
{$DEFINE __REMOTECONTROL_H}

//{ $ INCLUDE "windows.h"}

{$IFDEF __cplusplus}
{$ENDIF}


{+// }
{-* Function return codes }
{= }

const
  RMTCTRLERR_OK = 0; {// Success, no error}
const
  RMTCTRLERR_NOMOREDATA = 1; {// End of registers list}
const
  RMTCTRLERR_NOCFGFILE = 2; {// No config file found}
const
  RMTCTRLERR_WRONGCFGFILE = 3; {// wrong CFG file}
const
  RMTCTRLERR_BUFFERTOOSHORT = 4; {// application provided return buffer is too short}
const
  RMTCTRLERR_NOSUCHDEVICE = 5; {// no such device name}
const
  RMTCTRLERR_NOSUCHREGISTER = 6; {// no such register name}
const
  RMTCTRLERR_CANTCONNECT = 7;
const
  RMTCTRLERR_TIMEOUT = 8; {// timeout waiting for device answer}
const
  RMTCTRLERR_READONLY = 9; {// register is read only}
const
  RMTCTRLERR_NOT_NV = 10; {// register is not NV}
const
  RMTCTRLERR_HILIMIT = 11; {// attempt to set value above upper limit}
const
  RMTCTRLERR_LOLIMIT = 12; {// attempt to set value below bottom limit}
const
  RMTCTRLERR_NOSUCHVALUE = 13; {// attempt to set not allowed value}
const
  RMTCTRLERR_NOTLOGGED = 14; {// register is not being logged}
const
  RMTCTRLERR_MEMORYFULL = 15; {// not enough memory}
const
  RMTCTRLERR_LOGISEMPTY = 16; {// no data in the queue yet}
const
  RMTCTRLERR_ALREADYCONNECTED = 17; {// already connected, please disconnect first}
const
  RMTCTRLERR_NOTYETCONNECTED = 18; {// not connected, please connect first}


{+// }
{-Function rcGetRegFromLogAsDouble and rcGetRegFromLogAsString }
{-may or return value with RMTCTRLERR_LOGOVERFLOW. }
{-This happens when data retrieval succeeds, but Log FIFO }
{-overflow is detected. }
{= }
const
  RMTCTRLERR_LOGOVERFLOW = $80000000; {// Log FIFO overrun occured}


{+// }
{-* Functions list }

{-Connection functions: }
{-rcConnect }
{-rcDisconnect }

{-Devices and registers enumeration functions: }
{-rcGetFirstDeviceName }
{-rcGetNextDeviceName }
{-rcGetFirstRegisterName }
{-rcGetNextRegisterName }

{-Register access functions: }
{-rcGetRegAsDouble }
{-rcSetRegFromDouble }
{-rcSetRegNVFromDouble }
{-rcGetRegAsString }
{-rcSetRegFromString }
{-rcSetRegNVFromString }

{-Register log and access functions: }
{-rcLogRegStart }
{-rcLogRegStop }
{-rcGetRegFromLogAsDouble }
{-rcGetRegFromLogAsString }
{-* }
{= }



{+// }
{-Function: Connect }

{-Description: Makes a connection attempt }

{-Arguments: connectiontype: 0 - direct }
{-1 - rs232 }
{-comportnumber: 1 - COM1 }
{-2 - COM2 }
{-... }

{-Return value: error code, one of RMTCTRLERR_xxx list }
{= }
var
  rcConnect: function(connectiontype: Integer; 
                      comportnumber: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: Disconnect }

{-Description: Disconnects }

{-Arguments: none }

{-Return value: error code, one of RMTCTRLERR_xxx list }
{= }
var
  rcDisconnect: function: Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: GetFirstDeviceName }

{-Description: Get the name of first device in the list. Use }
{-GetNextDeviceName() in a loop to retrieve all }
{-device names. }

{-Arguments: devname: pointer to C string. GetFirstDeviceName will }
{-write to*devname }
{-maxdevnamelen: Maximum length of devname string including }
{-terminatiion character. }

{-Return value: error code, one of RMTCTRLERR_xxx list }
{= }
var
  rcGetFirstDeviceName: function(devname: PChar;
                                 maxdevnamelen: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};



{+// }
{-Function: GetNextDeviceName }

{-Description: Get the name of next device in the list. Use }
{-GetFirstDeviceName() to restart retrieval from }
{-the beginning of device names list }

{-Arguments: devname: pointer to C string. GetFirstDeviceName will }
{-write to*devname }
{-maxdevnamelen: Maximum length of devname string including }
{-terminatiion character. }

{-Return value: error code, one of RMTCTRLERR_xxx list }
{-On the end of devices list, GetNextDeviceName will }
{-return RMTCTRLERR_NOMOREDATA }
{= }
var
  rcGetNextDeviceName: function(devname: PAnsiChar;
                                maxdevnamelen: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: GetFirstRegisterName }

{-Description: Get first register name of specific device. Use }
{-GetNextRegName() in a loop to retrieve all device }
{-register names. }

{-Arguments: devname: pointer to device name string. }

{-regname: pointer to register name string. GetFirstRegisterName will }
{-write to*regname }
{-maxregnamelen: Maximum length of string including terminatiion }
{-character. }

{-Return value: error code, one of RMTCTRLERR_xxx list }
{= }
var
  rcGetFirstRegisterName: function(const devname: PAnsiChar;
                                   regname: PAnsiChar;
                                   maxregnamelen: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: GetNextRegisterName }

{-Description: Get next register name of specific device. Use GetFirstRegisterName() }
{-to reset retrival of register names from the beginning. }

{-Arguments: regname: pointer to C string. GetNextParName will }
{-write to*parname }

{-maxregnamelen: Maximum length of string including terminatiion }
{-character. }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{-On the end of registers list, GetNextRegName will }
{-return RMTCTRLERR_NOMOREDATA }
{= }
var
  rcGetNextRegisterName: function(regname: PAnsiChar;
                                  maxparlen: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: GetRegAsDouble }

{-Description: Return register value as double. }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-value: pointer to double, rcGetRegAsDouble will overwrite }
{-on success }

{-timeout: timeout in milliseconds. (-1) - infinite timeout }

{-timestamp: pointer to int. In case timestamp is not a NULL, }
{-rcGetRegAsDouble will write to*timestamp the time }
{-stamp of received message }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcGetRegAsDouble: function(const devname: PAnsiChar;
                             const regname: PAnsiChar;
                             var value: Double; 
                             timeout: Integer; 
                             var timestamp: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: SetRegFromDouble }

{-Description: Set register value from double variable. }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-value: value }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcSetRegFromDouble: function(const devname: PAnsiChar;
                               const regname: PAnsiChar;
                               value: Double): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: SetRegNVFromDouble }

{-Description: Set register NV value from double variable. }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-value: value }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcSetRegNVFromDouble: function(const devname: PAnsiChar;
                                 const regname: PAnsiChar;
                                 value: Double): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: GetRegAsString }

{-Description: Return register value as string. }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-value: pointer to string, GetRegAsString will overwrite }

{-maxvallen: maximum length of value string, including terminating character }

{-timeout: timeout in milliseconds. (-1) - infinite timeout }

{-timestamp: pointer to int. In case timestamp is not a NULL, }
{-rcGetRegAsDouble will write to*timestamp the time }
{-stamp of received message }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcGetRegAsString: function(const devname: PAnsiChar;
                             const regname: PAnsiChar;
                             value: PAnsiChar;
                             maxvallen: Integer; 
                             timeout: Integer; 
                             var timestamp: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: SetRegFromString }

{-Description: Set register value from string. }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-value: pointer to string }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcSetRegFromString: function(const devname: PAnsiChar;
                               const regname: PAnsiChar;
                               const value: PAnsiChar): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};



{+// }
{-Function: SetRegNVFromString }

{-Description: Set register value from string. }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-value: pointer to string }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcSetRegNVFromString: function(const devname: PAnsiChar;
                                 const regname: PAnsiChar;
                                 const value: PAnsiChar): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};



{+// }
{-Function: rcLogRegStart }

{-Description: Start logging register }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-queuesize: Size of memory to allocate }
{-for data queue. }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcLogRegStart: function(const devname: PAnsiChar;
                          const regname: PAnsiChar;
                          queuesize: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: rcLogRegStop }

{-Description: Stop logging register }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcLogRegStop: function(const devname: PAnsiChar;
                         const regname: PAnsiChar): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF};



{+// }
{-Function: rcGetRegFromLogAsDouble }

{-Description: Get register value from log queue as double value. }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-value: pointer to double, rcGetRegAsDouble will overwrite }

{-timestamp: pointer to int. In case timestamp is not a NULL, }
{-rcGetRegAsDouble will write to*timestamp the time }
{-stamp of received message }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcGetRegFromLogAsDouble: function(const devname: PAnsiChar;
                                    const regname: PAnsiChar;
                                    var value: Double; 
                                    var timestamp: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 



{+// }
{-Function: rcGetRegFromLogAsString }

{-Description: Get register value from log queue as string. }

{-Arguments: devname: pointer to device name string }

{-regname: pointer to register name string. }

{-value: pointer to string, GetRegAsString will overwrite }

{-maxvallen: maximum length of value string, including terminating character }

{-timestamp: pointer to int. In case timestamp is not a NULL, }
{-rcGetRegAsDouble will write to*timestamp the time }
{-stamp of received message }

{-Return value: error code, one of RMTCTRLERR_xxx list. }
{= }
var
  rcGetRegFromLogAsString: function(const devname: PAnsiChar;
                                    const regname: PAnsiChar;
                                    value: PAnsiChar;
                                    maxvallen: Integer; 
                                    var timestamp: Integer): Integer cdecl  {$IFDEF WIN32} stdcall {$ENDIF}; 





{$IFDEF __cplusplus}
{$ENDIF}


{$ENDIF //__REMOTECONTROL_H}

var
  DLLLoaded: Boolean { is DLL (dynamically) loaded already? }
    {$IFDEF WIN32} = False; {$ENDIF}

implementation

var
  SaveExit: pointer;
  DLLHandle: THandle;
{$IFNDEF MSDOS}
  ErrorMode: Integer;
{$ENDIF}

  procedure NewExit; far;
  begin
    ExitProc := SaveExit;
    FreeLibrary(DLLHandle)
  end {NewExit};

procedure LoadDLL;
begin
  if DLLLoaded then Exit;
{$IFNDEF MSDOS}
  ErrorMode := SetErrorMode($8000{SEM_NoOpenFileErrorBox});
{$ENDIF}
  DLLHandle := LoadLibrary('REMOTECONTROL.DLL');
  if DLLHandle >= 32 then
  begin
    DLLLoaded := True;
    SaveExit := ExitProc;
    ExitProc := @NewExit;
    @rcConnect := GetProcAddress(DLLHandle,'rcConnect');
  {$IFDEF WIN32}
    Assert(@rcConnect <> nil);
  {$ENDIF}
    @rcDisconnect := GetProcAddress(DLLHandle,'rcDisconnect');
  {$IFDEF WIN32}
    Assert(@rcDisconnect <> nil);
  {$ENDIF}
    @rcGetFirstDeviceName := GetProcAddress(DLLHandle,'rcGetFirstDeviceName');
  {$IFDEF WIN32}
    Assert(@rcGetFirstDeviceName <> nil);
  {$ENDIF}
    @rcGetNextDeviceName := GetProcAddress(DLLHandle,'rcGetNextDeviceName');
  {$IFDEF WIN32}
    Assert(@rcGetNextDeviceName <> nil);
  {$ENDIF}
    @rcGetFirstRegisterName := GetProcAddress(DLLHandle,'rcGetFirstRegisterName');
  {$IFDEF WIN32}
    Assert(@rcGetFirstRegisterName <> nil);
  {$ENDIF}
    @rcGetNextRegisterName := GetProcAddress(DLLHandle,'rcGetNextRegisterName');
  {$IFDEF WIN32}
    Assert(@rcGetNextRegisterName <> nil);
  {$ENDIF}
    @rcGetRegAsDouble := GetProcAddress(DLLHandle,'rcGetRegAsDouble');
  {$IFDEF WIN32}
    Assert(@rcGetRegAsDouble <> nil);
  {$ENDIF}
    @rcSetRegFromDouble := GetProcAddress(DLLHandle,'rcSetRegFromDouble');
  {$IFDEF WIN32}
    Assert(@rcSetRegFromDouble <> nil);
  {$ENDIF}
    @rcSetRegNVFromDouble := GetProcAddress(DLLHandle,'rcSetRegNVFromDouble');
  {$IFDEF WIN32}
    Assert(@rcSetRegNVFromDouble <> nil);
  {$ENDIF}
    @rcGetRegAsString := GetProcAddress(DLLHandle,'rcGetRegAsString');
  {$IFDEF WIN32}
    Assert(@rcGetRegAsString <> nil);
  {$ENDIF}
    @rcSetRegFromString := GetProcAddress(DLLHandle,'rcSetRegFromString');
  {$IFDEF WIN32}
    Assert(@rcSetRegFromString <> nil);
  {$ENDIF}
    @rcSetRegNVFromString := GetProcAddress(DLLHandle,'rcSetRegNVFromString');
  {$IFDEF WIN32}
    Assert(@rcSetRegNVFromString <> nil);
  {$ENDIF}
    @rcLogRegStart := GetProcAddress(DLLHandle,'rcLogRegStart');
  {$IFDEF WIN32}
    Assert(@rcLogRegStart <> nil);
  {$ENDIF}
    @rcLogRegStop := GetProcAddress(DLLHandle,'rcLogRegStop');
  {$IFDEF WIN32}
    Assert(@rcLogRegStop <> nil);
  {$ENDIF}
    @rcGetRegFromLogAsDouble := GetProcAddress(DLLHandle,'rcGetRegFromLogAsDouble');
  {$IFDEF WIN32}
    Assert(@rcGetRegFromLogAsDouble <> nil);
  {$ENDIF}
    @rcGetRegFromLogAsString := GetProcAddress(DLLHandle,'rcGetRegFromLogAsString');
  {$IFDEF WIN32}
    Assert(@rcGetRegFromLogAsString <> nil);
  {$ENDIF}
  end
  else
  begin
    DLLLoaded := False;
    { Error: REMOTECONTROL.DLL could not be loaded !! }
  end;
{$IFNDEF MSDOS}
  SetErrorMode(ErrorMode)
{$ENDIF}
end {LoadDLL};

begin
  LoadDLL;
end.
