unit Scan;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, TeEngine, Series, TeeProcs, Chart, REMOTECONTROL, StdCtrls,
  ComCtrls, Buttons;

type
  TfrmScan = class(TForm)
    Chart1: TChart;
    Chart2: TChart;
    Timer1: TTimer;
    btStartScan: TButton;
    btStopScan: TButton;
    TrackBar1: TTrackBar;
    btSetDAC: TButton;
    Series3: TLineSeries;
    Series1: TLineSeries;
    BitBtn1: TBitBtn;
    StaticText1: TStaticText;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btStartScanClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btStopScanClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure btSetDACClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
    var
    OnScan:Boolean;
    ForwardDir:Boolean;
    DACvalue:integer;
    ConnectedStatus:boolean;
    OldDAC:double;
    const
    ScanStep=20;
    MAX_DAC=4095;
    DefaultTimeout =100;
    procedure SetDAC;
    procedure Delay_ms(ms:integer);
  public
    { Public declarations }
  end;

var
  frmScan: TfrmScan;

implementation
uses DemoRemoteControl;

{$R *.dfm}

procedure TfrmScan.BitBtn1Click(Sender: TObject);
begin
Close;
end;

procedure TfrmScan.btSetDACClick(Sender: TObject);
begin
OldDAC:= TrackBar1.Position*50;
SetDAC;
OldDAC:=-1;
end;

procedure TfrmScan.btStartScanClick(Sender: TObject);
var Code, TimeStamp:integer;
begin
Code:= rcGetRegAsDouble ('SL ctrl:60','DAC', OldDAC , DefaultTimeout, timestamp);   //getting value for a chart
if Code<>0  then OldDAC:=-1;
DACvalue:=0;
rcSetRegFromDouble('SL ctrl:60','DAC', 0 );
Delay_ms(1000);
Code:=  rcLogRegStart('PHD1K000:48','Data', 10000);
Code:=  rcLogRegStart('SL ctrl:60','Time difference', 10000);
Series1.Clear;
Series3.Clear;
OnScan:=true;
end;

procedure TfrmScan.btStopScanClick(Sender: TObject);
begin
rcLogRegStop('PHD1K000:48','Data');
rcLogRegStop('SL ctrl:60','Time difference');
SetDAC;
OnScan:=false;
end;

procedure TfrmScan.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if OnScan then btStopScanClick(Sender);

//rcLogRegStop('PHD1K000:48','Data');
//rcLogRegStop('SL ctrl:60','Time difference');
//OnScan:=false;
//frmMain.Connected:=ConnectedStatus;
end;

procedure TfrmScan.Delay_ms(ms:integer);
var CurrentCounter:double;
begin
CurrentCounter:=GetTickCount;
repeat
Application.ProcessMessages;
until GetTickCount - CurrentCounter > ms;
end;

procedure TfrmScan.SetDAC;
begin
if OldDAC<>-1 then
  begin
  rcSetRegFromDouble('SL ctrl:60','DAC', 0 );
  Delay_ms(1500);
  rcSetRegFromDouble('SL ctrl:60','DAC', OldDAC );
  end;
end;

procedure TfrmScan.FormShow(Sender: TObject);
var code:integer;
Timestamp: Integer;
begin
//Code:=  rcLogRegStart('PHD1K000:48','Data', 10000);
//Code:=  rcLogRegStart('SL ctrl:60','Time difference', 10000);
//Code:= rcGetRegFromLogAsDouble ('SL ctrl:60','DAC', OldDAC , timestamp);   //getting value for a chart
//if Code<>0  then OldDAC:=-1;
//ConnectedStatus:=frmMain.Connected;
//frmMain.Connected:=false;
end;

procedure TfrmScan.Timer1Timer(Sender: TObject);
var code:integer;
ParameterValue:Double;
Timestamp: Integer;

begin
repeat
Code:=rcGetRegFromLogAsDouble ('PHD1K000:48','Data', ParameterValue , timestamp);   //getting value for a chart
if Code=0 then
      begin
      if OnScan then
        begin
        Series1.AddXY(DACvalue,ParameterValue);
        end;
      end;
Code:=rcGetRegFromLogAsDouble ('SL ctrl:60','Time difference', ParameterValue , timestamp);   //getting value for a chart
if Code=0 then
      begin
      if OnScan then
        begin
        Series3.AddXY(DACvalue,ParameterValue);
        end;
      end;
//until Code<>0;
//repeat
until Code<>0;

if OnScan then
 if DACvalue < MAX_DAC then
   begin
   rcSetRegFromDouble('SL ctrl:60','DAC', DACvalue );
   DACvalue:=DACvalue+ScanStep;
   end
 else
   begin
   OnScan:=false;
   btStopScanClick(Sender);
   end;
end;

procedure TfrmScan.TrackBar1Change(Sender: TObject);
begin
OldDAC:= TrackBar1.Position*50;
end;

end.
